#!/bin/sh

if [ $# -ne 1 ]; then
    echo "Usage: $0 PID" 1>&2
    exit 1
fi

readable_pattern='r[-w][-x]p'
executable_pattern='r[-w]xp'

grep "$executable_pattern" "/proc/$1/maps" | grep '\.so\(\.\|$\)' | sed -n 's/^\([0-9a-f]*-[0-9a-f]*\) .*$/\1/p' | ./findinstr "$1"
